#include <SPI.h>
#include <SD.h>
#include "lcd.h"
#include "sn76489.h"
#include "ym2612.h"

#define LCD_CS 0
#define CARD_CS 1
#define YM_CS 2
#define SN_CS 3
#define SN_RDY 16
#define SN_WE 17
#define YM_IRQ 18
#define YM_IC 19
#define YM_A0 20
#define YM_A1 21
#define YM_RD 22
#define YM_WR 23

lcd lcd( LCD_CS );
sn76489 sn( SN_WE, SN_CS, SN_RDY );
ym2612 ym( YM_CS, YM_IC, YM_A0, YM_A1, YM_RD, YM_WR, YM_IRQ );

void setup() {
  lcd.init();
  lcd.clear();
  lcd.graphics();
  lcd.display();
  delay( 1000 );
  lcd.text();

  lcd.line1 = "LCD Pass";
  lcd.print();
  delay( 1000 );

  while ( !SD.begin( CARD_CS )) {
    lcd.line2 = "Card Failed";
    delay( 1000 );
  }
  File root = SD.open( "/" );
  lcd.line2 = "Card Pass";
  lcd.print();
  delay( 1000 );

  sn.init();
  sn.ping();
  lcd.line3 = "SN76489 Pass";
  lcd.print();
  delay( 1000 );
  
  ym.init();
  ym.ping();
  lcd.line4 = "YM2612 Pass";
  lcd.print();
  delay( 1000 );

  File entry = root.openNextFile();
  while( entry ) {
    lcd.line1 = entry.name();
    lcd.print();
    delay( 500 );
    entry.close();
    entry = root.openNextFile();
  }
  lcd.line2 = "no more files";
  lcd.print();
  delay( 500 );  
}

void loop() {

}
